; CoupledTrackBar, v.2005-12-04
; http://www.geocities.com/xmemor/2lz/tinyasm.html
; http://www.geocities.com/xmemor/2lz/coupledtrackbar.zip
;################################################################################################

.386
.model  flat,stdcall
option  casemap:none

include    \masm32\include\windows.inc
include    \masm32\include\user32.inc
include    \masm32\include\kernel32.inc
include    \masm32\include\gdi32.inc
include 	 \masm32\include\comctl32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comctl32.lib

.const
trackid_top	equ 3001
trackid_bot	equ 3002
buttonid		equ 3003
timerid			equ 2005

.data
AppName			db "CoupledTrackBar",0
DlgName			db "Dlg",0
about				db "by kero <geocities.com/xmemor>, v.2005-12-04",0

.data?
htrack_top	HWND ?
htrack_bot	HWND ?
hbutton			HWND ?
OldTrackPrc dd ?
pos_bot			dd ?
flag				dd ?

.code

;################################################################################################

NewTrackProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax,uMsg
	.if eax==WM_LBUTTONDOWN || eax==WM_KEYDOWN
		mov flag,1
	.elseif eax==WM_LBUTTONUP || eax==WM_KEYUP
		invoke SendMessage,htrack_top,TBM_GETPOS,0,0
		mov pos_bot,eax
		invoke SendMessage,htrack_bot,TBM_SETPOS,1,eax
		mov flag,0
	.endif
	invoke CallWindowProc,OldTrackPrc,hWnd,uMsg,wParam,lParam
	ret
NewTrackProc endp

;################################################################################################

DlgProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax,uMsg
	mov ecx,lParam
	mov edx,wParam

	.if	eax==WM_CLOSE
		invoke KillTimer,hWnd,timerid
		invoke EndDialog,hWnd,0

	.elseif eax==WM_INITDIALOG
		invoke GetDlgItem,hWnd,trackid_top
		mov htrack_top,eax
		invoke SetWindowLong,htrack_top,GWL_WNDPROC,addr NewTrackProc
		mov OldTrackPrc,eax
		invoke GetDlgItem,hWnd,trackid_bot
		mov htrack_bot,eax
		invoke GetDlgItem,hWnd,buttonid
		mov hbutton,eax
		invoke SendMessage,htrack_top,TBM_SETRANGE,0,00ff0000h   ; (0...255)
		invoke SendMessage,htrack_top,TBM_SETPOS,1,pos_bot
		invoke SendMessage,htrack_top,TBM_SETTICFREQ,8,0
		invoke SendMessage,htrack_bot,TBM_SETRANGE,0,00ff0000h   ; (0...255)
		invoke SendMessage,htrack_bot,TBM_SETPOS,1,pos_bot
		invoke SendMessage,htrack_bot,TBM_SETTICFREQ,8,0
		invoke SendMessage,hbutton,BM_CLICK,0,0

	.elseif eax==WM_COMMAND && edx==buttonid
		invoke SendMessage,hbutton,BM_GETCHECK,0,0
		.if eax==0
			invoke KillTimer,hWnd,timerid
		.else
			invoke SetTimer,hWnd,timerid,200,0
		.endif

	.elseif eax==WM_TIMER && edx==timerid
		inc pos_bot
		invoke SendMessage,htrack_bot,TBM_SETPOS,1,pos_bot
		.if flag==0
			invoke SendMessage,htrack_top,TBM_SETPOS,1,pos_bot
		.endif

	.elseif eax==WM_HSCROLL && ecx==htrack_top
		invoke SendMessage,htrack_bot,TBM_GETPOS,0,0
		push eax
		inc eax
		invoke SendMessage,htrack_bot,TBM_SETPOS,1,eax
		pop eax
		invoke SendMessage,htrack_bot,TBM_SETPOS,1,eax

	.else
		xor eax,eax
		ret

	.endif
	xor eax,eax
	inc eax
	ret
DlgProc endp

;################################################################################################

start:
	invoke GetModuleHandle,0
	invoke DialogBoxParam,eax,offset DlgName,0,offset DlgProc,0
	invoke ExitProcess,eax
  invoke InitCommonControls
end start

;################################################################################################
